
' ================================================================================================
'  Theremino System - Risonance frequency for a Loop Antenna made with shielded cable
' ================================================================================================

' ------------------------------------------------ SMD components bobbin - 12 meters shielded cable - 1.12 MHz
'Dim nturns As Double = 38
'Dim CoilDiameterCm As Double = 6
'Dim CoilThicknessCm As Double = 5
'Dim CoilLengthCm As Double = 1
'Dim PicoFaradPerMeter As Double = 75

' ------------------------------------------------ double wire bobbin 12 mH - 33 KHz
'Dim nturns As Double = 270 + 270
'Dim CoilDiameterCm As Double = 2.8
'Dim CoilThicknessCm As Double = 0.8
'Dim CoilLengthCm As Double = 0.7
'Dim PicoFaradPerMeter As Double = 170

' ------------------------------------------------ tape bobbin 1000 turns - 35.5 mH - 71 ohm - wire 0.18 - 62 KHz
'Dim nturns As Double = 1000
'Dim CoilDiameterCm As Double = 3.2
'Dim CoilThicknessCm As Double = 0.35
'Dim CoilLengthCm As Double = 1.5
'Dim PicoFaradPerMeter As Double = 7

' ------------------------------------------------ SMD components bobbin - wire 0.18 - 25.2mH - 71KHz
'Dim nturns As Double = 500
'Dim CoilDiameterCm As Double = 6
'Dim CoilThicknessCm As Double = 0.2
'Dim CoilLengthCm As Double = 0.85
'Dim PicoFaradPerMeter As Double = 7

' ------------------------------------------------ Fashion bobbin 55mm - wire 0.2 to 0.3 - 
Dim nturns As Double = 500
Dim CoilDiameterCm As Double = 6
Dim CoilThicknessCm As Double = 0.5
Dim CoilLengthCm As Double = 1.0
Dim PicoFaradPerMeter As Double = 7



' NOT TESTED

' ------------------------------------------------ tape bobbin 600 turns - 12 mH - wire 0.18
'Dim nturns As Double = 580
'Dim CoilDiameterCm As Double = 3.2
'Dim CoilThicknessCm As Double = 0.35
'Dim CoilLengthCm As Double = 1.5
'Dim PicoFaradPerMeter As Double = 50

' ------------------------------------------------ Magnetoterapy coil - 12 mH
'Dim nturns As Double = 360
'Dim CoilDiameterCm As Double = 6
'Dim CoilThicknessCm As Double = 1.2
'Dim CoilLengthCm As Double = 1
'Dim PicoFaradPerMeter As Double = 50


Dim ResFreqHz As Double
Dim CableLengthCm As Double
Dim CapacitancePf As Double
Dim Induc_uH As Double

Sub AppStart() 
	CableLengthCm = nturns * (CoilDiameterCm * PI)
	CapacitancePf = CableLengthCm / 100 * PicoFaradPerMeter 
	Induc_uH = InductanceMicroHenry(nturns, CoilDiameterCm, CoilThicknessCm, CoilLengthCm) 
	ResFreqHz = ResonanceFrequencyHz(CapacitancePf, Induc_uH)
	
	label1.text &= nturns.ToString("N turns              = 0") & vbcrlf
	label1.text &= (CableLengthCm/100).ToString("Cable length     (m) = 0")  & vbcrlf
	label1.text &= CapacitancePf.ToString("Capacitance     (pF) = 0") & vbcrlf
	label1.text &= Induc_uH.ToString("Inductance      (uH) = 0") & vbcrlf
	label1.text &= (ResFreqHz/1000).ToString("Resonance freq (KHz) = 0") & vbcrlf
End Sub

Function ResonanceFrequencyHz(pF As Double, uH As Double) As Double
	ResonanceFrequencyHz = 1 / (pi * math.sqrt(pF * uH / 1e18))
End Function

Function InductanceMicroHenry(n As Double, diamCm As Double, thickCm As Double, lenCm As Double) As Double
	Dim MeanRadius As Double = diamCm / 2 + thickCm / 2
	InductanceMicroHenry = 0.315 * nturns^2 * MeanRadius^2 / (9 * lenCm + 10 * thickCm + 6 * MeanRadius)
End Function


' ------------------------------------------------------------------------------------------------
'  Main
' ------------------------------------------------------------------------------------------------
Sub Main(ByVal s() As String)
	If Form1 IsNot Nothing Then Return
	Form1 = New form
	InitializeComponents
	MemoryMappedFile_Init
	While Form1.Visible
		Application.DoEvents
		Threading.Thread.Sleep(10)
	End While
End Sub

Sub Form1_load(sender As Object, e As System.EventArgs) Handles Form1.load
	AppStart
End Sub


' ---------------------------------------------------------------------- User Interface Components
Dim WithEvents Form1 As Form
Dim Label1 As Label = New Label
Dim WithEvents Button1 As Button = New Button

Sub InitializeComponents()
	Application.EnableVisualStyles
	form1.SuspendLayout
	' ------------------------------------------------------------------ Form
	Form1.Text = "Theremino Script - Loop Antenna Resonance"
	Form1.ClientSize = New System.Drawing.Size(520, 600)
	Form1.StartPosition = FormStartPosition.CenterScreen
	Form1.FormBorderStyle = FormBorderStyle.Sizable
	Form1.MaximizeBox = False
	Form1.KeyPreview = True
	' ------------------------------------------------------------------ Label 1
	Label1.BorderStyle = BorderStyle.Fixed3D
	Label1.Location = New Point(8, 8)
	Label1.Width = form1.clientsize.Width-16
	Label1.Height = form1.clientsize.Height-16
	Label1.Font = New Font("Courier New", 10 )
	Label1.Anchor = AnchorStyles.Top Or AnchorStyles.Left Or AnchorStyles.right Or AnchorStyles.bottom
	Form1.Controls.Add(Label1)
	' ------------------------------------------------------------------ 
	Form1.ResumeLayout
	Form1.PerformLayout()
	Form1.Show
End Sub






